# Update Collections

> Source: https://truto.one/docs/api-reference/unified-ticketing-api/collections/update/

`PATCH /unified/ticketing/collections/{id}`

Resource: **Collections** · API: **Unified Ticketing API**

## Supported integrations

Hive, Microsoft 365, Microsoft Planner, Pivotal Tracker, Planhat, Productboard, Quickbase for Project Management, SolarWinds Service Desk, Todoist, Wrike, Zoho Projects

## Path parameters

- **`id`** _(string, required)_
  The ID of the resource.

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`etag`** _(string)_
  The unique identifier for the specific version of the resource.
- **`type`** _(string)_
  The type of the collection
  Allowed: `component`, `epic`, `product`, `project`, `section`
- **`organization`** _(object)_
- **`workspace`** _(object)_

## Request body

- **`name`** _(string)_
  The name of the collection
- **`description`** _(string)_
  The description of the collection
- **`custom_fields`** _(unknown)_
- **`parent_collection`** _(object)_
  Set this value when type is component.
  - **`id`** _(string, required)_
  - **`type`** _(enum, required)_
    Allowed: `component`, `product`
- **`parent_collection_id`** _(string)_
  The parent collection id
- **`title`** _(unknown)_
- **`flag`** _(string)_
  Allowed: `internal`, `external`
- **`status`** _(string)_
  The status of the collection.
  Allowed: `completed`, `active`
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for a collection
- **`name`** _(string)_
  The name of the collection
- **`description`** _(string)_
  The description of the collection
- **`type`** _(string)_
  The type of the collection
- **`parent_collection_id`** _(string)_
  The parent collection id
- **`urls`** _(array<object>)_
  The URLs of the collection
  - **`url`** _(string)_
    The URL of the collection
- **`workspace`** _(object)_
  - **`id`** _(string)_
    The unique identifier for a workspace
  - **`name`** _(string)_
    The name of the workspace
- **`created_at`** _(string)_
  The date and time when the collection was created
- **`updated_at`** _(string)_
  The date and time when the collection was updated
- **`etag`** _(string)_
  The unique identifier for the specific version of the resource.
- **`entity_type`** _(string)_
  The type of entity that belongs to this collection
  Allowed: `contact`, `ticket`
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X PATCH 'https://api.truto.one/unified/ticketing/collections/{id}?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "name": "your_name",
  "description": "your_description",
  "parent_collection": {},
  "parent_collection_id": "your_parent_collection_id",
  "flag": "internal",
  "status": "completed",
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "name": "your_name",
  "description": "your_description",
  "parent_collection": {},
  "parent_collection_id": "your_parent_collection_id",
  "flag": "internal",
  "status": "completed",
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/ticketing/collections/{id}?integrated_account_id=${integratedAccountId}`, {
  method: 'PATCH',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ticketing/collections/{id}"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "name": "your_name",
    "description": "your_description",
    "parent_collection": {},
    "parent_collection_id": "your_parent_collection_id",
    "flag": "internal",
    "status": "completed",
    "remote_data": {}
}

response = requests.patch(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.update(
  'ticketing',
  'collections',
  '<resource_id>',
  {
  "name": "your_name",
  "description": "your_description",
  "parent_collection": {},
  "parent_collection_id": "your_parent_collection_id",
  "flag": "internal",
  "status": "completed",
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.update(
        "ticketing",
        "collections",
        "<resource_id>",
        {
        "name": "your_name",
        "description": "your_description",
        "parent_collection": {},
        "parent_collection_id": "your_parent_collection_id",
        "flag": "internal",
        "status": "completed",
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
